Web-Maker ![Build](https://travis-ci.org/chinchang/web-maker.svg?branch=master) [![Gitter](https://badges.gitter.im/web-maker-app/Lobby.svg)](https://gitter.im/web-maker-app/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge)
======

**Web-Maker** is an offline playground for your web experiments. Something like CodePen or JSFiddle, but much more faster and offline supported because it runs completely on your system.

### [Install Chrome extension](https://chrome.google.com/webstore/detail/web-maker/lkfkkhfhhdkiemehlpkgjeojomhpccnh)

or

### [Go to Web App](https://webmakerapp.com/app/)

![Screenshot](/ss1.png)

### Features

* Supports Preprocessors: HTML (Pug & Markdown), CSS (SCSS, LESS & Stylus, Atomic CSS) & JavaScript (ES6, TypeScript & CoffeeScript)
* Works offline
* Inbuilt Console
* Save and load your creations
* Auto-save feature
* Code auto-completion
* Easy addition of popular JS & CSS libraries
* Import & Export all creations anytime, anywhere
* Multiple editor themes & other configurable settings
* Font options + use any system font!
* Very easily accessible. Simply open a new tab in Chrome! (in chrome extension only)
* Multiple layouts to choose from
* Capture preview screenshot (in Chrome extension only)
* Save as HTML file
* Edit in CodePen

Follow [@webmakerApp](https://twitter.com/intent/follow?screen_name=webmakerApp) for updates or tweet out feature requests and suggestions.

### Support Web Maker

Hi! I am Kushagra Gour. Web Maker is a free and open-source project. To keep myself motivated for working on such open-source and free [side projects](https://kushagragour.in/lab/), I have launched a [Patreon campaign](https://patreon.com/kushagra). Your pledge, no matter how small, will act as an appreciation towards my work and keep me going forward making Web Maker more awesome🔥.

[![Become a patron](/src/patreon.png)](https://patreon.com/kushagra)

If not that, you can support by simply sharing about how much you love 💖 [@webmakerapp](https://twitter.com/webmakerApp).

Web Maker stays stable as rock with every release, thanks to the sponsored testing on the awesome <a href="http://browserstack.com/">BrowserStack</a>! 
<a href="http://browserstack.com/"><img alt="Browserstack logo" src="https://p14.zdusercontent.com/attachment/1015988/l8WVB4MN3qYX5Vfa2GYq9OhWc?token=eyJhbGciOiJkaXIiLCJlbmMiOiJBMTI4Q0JDLUhTMjU2In0..LkuIkSrr7JH57LIX8ndSRQ.vNbwvs4ANfS_axE84eEYNrqx79qup9c1w0gK7z7lw9nq2YV05HLKdKb1GbXDAb-oYFqeyWo3D8RSaXtcq0kK6hmM20D95sS0IiSdqLo8o86QEPvrMkxjhg0Nu0yViwlFnDVhjrMoeKlFSMyDexFf-v_ejBJdNrr_rr_8Nc_D1BLa82BgUPaahkIHsJFXmNmS51AbhN4BbxEnAcYNf11xqCTLbN1XwZk6FmSgWjWDIscxF3TpGHTGYLOq4qcdRGXT_08C8rm6SKqEV9FVN7AxnyW3-pzhGZ_QpgzEYg_d-IY.9_wfbVeTNES4ZpwgzPg66A" height="100"></a>

### License

MIT Licensed

Copyright (c) 2018 Kushagra Gour, [webmakerapp.com](https://webmakerapp.com)
